import es, playerlib, gamethread, cfglib

############  SETTINGS  ############

#health for a hit (make negative to subtract health)
hitreward = 5

#health penalty for a missed shot (this gets subtracted, make value negative to add health)
misshp = 10

#do not give penalties when player health is below this
minhp = 1

#teamhit action: 0 = count as a miss, 1 = give penalty
teammode = 1

#teamhit penalty
teamhit = 20

#turn on or off noblock
noblock = 1

####################################

info = es.AddonInfo()
info.name     = "EveryHit"
info.version  = "1.0"
info.url      = ""
info.basename = "EveryHit"
info.author   = "RubenL"
es.ServerVar('EveryHit_ver', info.version, 'EveryHit by RubenL').makepublic()

def load():
    es.server.cmd("es_xdoblock corelib/noisy_on")
    es.msg('#multi', '#green[EveryHit]#lightgreen Loaded.')
    
def unload():
    es.msg('#multi', '#green[EveryHit]#lightgreen Unloaded.')
   
def round_start(ev):
    es.msg('#multi', '#green[EveryHit]#lightgreen Is running on this server. Don\'t miss a bullet!')
    if noblock == 1:
        es.msg('#multi', '#green[EveryHit]#lightgreen NoBlock is #defaultON')
    else:
        es.msg('#multi', '#green[EveryHit]#lightgreen NoBlock is #defaultOFF')
	
def player_hurt(ev): 
    attacker = playerlib.getPlayer(ev['attacker'])
    atteam = ev['es_attackerteam']
    victim = playerlib.getPlayer(ev['userid'])
    viteam = ev['es_userteam']
    if atteam == viteam:
	    #team hit
        if teammode == 1:
            if attacker.health > minhp:
                attacker.health += misshp
            attacker.health -= teamhit
    if atteam != viteam:
        #enemy hit
        if attacker.health > minhp:
            attacker.health += misshp
        attacker.health += hitreward
    if attacker.health < 1:
        attacker.slay()
		
	#hit display
    hitgroup = int(ev['hitgroup'])
    if hitgroup == 0:
        hitname = 'everything'
    if hitgroup == 1:
        hitname = 'head'
    if hitgroup == 2:
        hitname = 'chest'
    if hitgroup == 3:
        hitname = 'stomach'
    if hitgroup == 4:
        hitname = 'left arm'
    if hitgroup == 5:
        hitname = 'right arm'
    if hitgroup == 6:
        hitname = 'left leg'
    if hitgroup == 7:
        hitname = 'right leg'

    es.tell(ev['attacker'],'#multi', '#green[EveryHit]#lightgreen You did #default' + str(ev['dmg_health']) + '#lightgreen damage to #default' + victim.name + '#lightgreen\'s #default' + hitname)

def weapon_fire(ev): 
    player = playerlib.getPlayer(ev['userid'])

    bullets = 1
    weap = ev['es_userweapon']
    #if weap == 'weapon_famas' or weap == 'weapon_glock':
    #    bullets = 3
    if weap == 'weapon_xm1014':
        bullets = 7
    if weap == 'weapon_m3':
        bullets = 8	
	# AWP COUNTS AS 2 <- REMOVE IF UNWANTED
    if weap == 'weapon_awp':
        bullets = 2	
		
    for x in range(0,bullets):
        if player.health > minhp:
            if player.health > minhp + misshp:
                player.health -= misshp
            else:
                player.health = minhp

def bullet_impact(ev):
    #if a bullet hits a surface, check the owner's health.
    player = playerlib.getPlayer(ev['userid'])
    if player.health < 1:
        player.slay()


def player_say(ev):
    uid = ev['userid']
    player = playerlib.getPlayer(uid)
    
	#script running check command thingy
    if ev['text'] == "EveryHit" or ev['text'] == "!eh":
        es.tell(uid, '#multi', '#green[EveryHit]#lightgreen Is running.')
    
	#noobsayer-pwnage
    if ev['text'] == "noob" or ev['text'] == "n00b" or ev['text'] == "n0ob" or ev['text'] == "no0b":
        if player.isdead == 0:
            player.burn()
            es.msg('#multi', '#green[EveryHit]#default ' + player.name + '#lightgreen Got 0wned.')

def player_spawn(ev):
    #noblock code runs on player spawn
    if noblock == 1:
        uid = ev['userid']
        player = playerlib.getPlayer(uid)
        es.setplayerprop(ev['userid'], 'CBaseEntity.m_CollisionGroup', 2)